<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="create_client_receipt"
  >
    <v-form ref="receipt" @submit.prevent="submit" lazy-validation>
      <v-card>
        <v-card-title class="light">Krijo një mandat</v-card-title>

        <v-container>
          <v-row class="mx-2">
            <v-col cols="12">
              <client-select v-model="request.creditable_id" />
            </v-col>
          </v-row>
          <v-row class="mx-2">
            <v-col cols="12">
              <v-select
                label="Arka / Banka *"
                v-model="request.cash_unit_id"
                :items="banks"
                item-text="unit_name"
                item-value="id"
                :rules="rules"
                required
              />
            </v-col>
          </v-row>
          <v-row class="mx-2">
            <v-col cols="12">
              <v-select
                label="Lloji*"
                :rules="rules"
                v-model="request.document_type"
                :items="documentTypes"
                required
              />
            </v-col>
          </v-row>
          <v-row class="mx-2">
            <v-col cols="6">
              <v-text-field
                label="Data*"
                type="date"
                v-model="request.date"
                :rules="rules"
                required
              />
            </v-col>
            <v-col cols="6">
              <v-text-field
                label="Vlera*"
                v-model="request.value"
                type="number"
                min="0"
                :rules="rules"
                required
              />
            </v-col>
          </v-row>
          <v-row class="mx-2">
            <v-col cols="6">
              <currency-select
                v-model="request.currency_id"
                @exchange-rate="event => (this.request.exchange_rate = event)"
                @currency_id="getCurrencyId"
              />
            </v-col>
            <v-col cols="6">
              <v-text-field
                label="Kursi*"
                v-model="request.exchange_rate"
                :rules="rules"
                required
              />
            </v-col>
          </v-row>
          <v-row class="mx-2">
            <v-col cols="6">
              <v-text-field label="Shënime" v-model="request.notes" />
            </v-col>
          </v-row>
        </v-container>
        <v-card-actions>
          <f-confirm-btn
            label="Konfirmo kredit"
            @click="confirm"
            :disabled="loading"
          />
          <v-spacer />
          <f-cancel-btn @click="close" />
          <f-submit-btn
            @click="submit"
            :loading="loading"
            :disabled="loading"
          />
        </v-card-actions>
      </v-card>
    </v-form>
  </v-dialog>
</template>

<script lang="ts">
import api from '@/plugins/api'
import { Component, Vue, Prop } from 'vue-property-decorator'
import FSubmitBtn from '@/components/buttons/FSubmitBtn.vue'
import FConfirmBtn from '@/components/buttons/FConfirmBtn.vue'
import FCancelBtn from '@/components/buttons/FCancelBtn.vue'
import CurrencySelect from '@/components/general/CurrencySelect.vue'
import ClientSelect from '@/components/general/ClientSelect.vue'

@Component({
  components: {
    FCancelBtn,
    FConfirmBtn,
    FSubmitBtn,
    CurrencySelect,
    ClientSelect,
  },
})
export default class CreateClientReceipt extends Vue {
  @Prop({ required: true }) value!: string

  request: any = {
    creditable_id: '',
    creditable_type: 'App\\Client',
    document_type: null,
    date: null,
    value: null,
    currency_id: null,
    exchange_rate: null,
    notes: null,
    cash_unit_id: null,
  }
  rules = [value => !!value || 'Fusha nuk mund të lihet bosh']
  loading = false
  banks = []
  documentTypes?: Array<string> = ['MA', 'MAB', 'MAC']

  public get selectedValue() {
    return this.value
  }

  public set selectedValue(newValue: string) {
    this.$emit('input', newValue)
    this.$emit('change', newValue)
  }
  close() {
    this.$emit('close')
  }

  submit() {
    this.loading = true
    const isValid = this.$refs.receipt as Vue & {
      validate: () => boolean
      reset: () => any
    }
    if (isValid.validate()) {
      api()
        .post('/api/account-management/receipts', this.request)
        .then(response => {
          alert(response.data.message)
          if (!(response && response.data && response.data.status === 0)) return

          this.$emit('refresh')
          isValid.validate()
          isValid.reset()
          this.close()
        })
        .finally(() => {
          this.loading = false
        })
    }
    isValid.validate()
  }

  confirm() {
    this.request.status_id = 16
    this.submit()
  }

  getCurrencyId(id) {
    this.request.currency_id = id
  }

  fetchBanks() {
    api()
      .get('/api/account-management/banks')
      .then(response => {
        this.banks = response.data.data
      })
      .finally(() => (this.loading = false))
  }

  mounted() {
    this.fetchBanks()
  }
}
</script>
